#ifndef __vtkPointSetCurvatureEstimation_h
#define __vtkPointSetCurvatureEstimation_h

#include <vtkSmartPointer.h>
#include "vtkPolyDataAlgorithm.h" //superclass

class vtkPoints;
class vtkPlane;

class vtkPointSetCurvatureEstimation : public vtkPolyDataAlgorithm
{

  public:
    static vtkPointSetCurvatureEstimation *New();
    void PrintSelf(ostream &os, vtkIndent indent);
    
    void SetRadius(const double r);
    vtkGetMacro(radius, double);
    
    void SetAutoRadius(vtkPolyData* input);
    
  protected:
    vtkPointSetCurvatureEstimation();
    
    int RequestData(vtkInformation *, vtkInformationVector **, vtkInformationVector *); //the function that makes this class work with the vtk pipeline
    
  private:
    double radius;
    bool UseAutoRadius;
};

void BestFitPlane(vtkPoints* points, vtkPlane* BestPlane);
void ComputeCenterOfMass(vtkPoints* points, double* Center);

#endif

